#! --------------------------------------------------------------------------- !
#! Class description:    Mappoint                                              !
#! Version:              1.01                                                  !
#! Description:          This class enables mappoint in your application       !
#! --------------------------------------------------------------------------- !
#! Authors:              Roel S.F. Abspoel (roel.abspoel@gmail.com)            !
#!                       William Cirino (w_cirino@hotmail.com)                 !
#!                                                                             !
#! Copyright    :        This template and class is freeware and provided      !
#!                       'as is'. You are welcome to share this template and   !
#!                       class in its origional form. If you make modifications!
#!                       please share these so they can be incorperated into   !
#!                       a new public release.                                 !
#!                                                                             !
#! --------------------------------------------------------------------------- !
#TEMPLATE (Mappoint, 'Mappoint'),FAMILY('ABC')
#EXTENSION (GlobalMappoint,'Global Mappoint Class'),APPLICATION
#! --------------------------------------------------------------------------- !

#SHEET
#TAB ('Mappoint')
#DISPLAY ('')
#DISPLAY ('This global extension includes the class')
#DISPLAY ('definitions for Mappoint.')
#DISPLAY ('')
#DISPLAY ('To use mappoint in your application add')
#DISPLAY ('the local mappoint extension to your procedure.')
#DISPLAY ('Follow the instructions in the local procedure')
#DISPLAY ('on how to activate / use the class.')
#DISPLAY ('')
#ENDTAB
#TAB ('About')
#DISPLAY ('Mappoint template and class Version 1.01')
#DISPLAY ('This template and class is freeware.')
#DISPLAY ('For support please visit the clarion newsgroups')
#DISPLAY ('or email either of the authors at:')
#DISPLAY ('')
#DISPLAY ('roel.abspoel@gmail.com')
#DISPLAY ('w_cirino@hotmail.com')
#DISPLAY ('')
#ENDTAB
#ENDSHEET
#! --------------------------------------------------------------------------- !
#AT (%BeforeGlobalIncludes)
#! --------------------------------------------------------------------------- !
  INCLUDE ('Mappoint.inc'),ONCE
#ENDAT

#! --------------------------------------------------------------------------- !
#! Local extension
#! --------------------------------------------------------------------------- !
#EXTENSION(LocalMappointClass,'Mappoint class instantiation'),PROCEDURE,REQ(GlobalMappoint(Mappoint))
! [PROCEDURE]
! NAME Main
#! --------------------------------------------------------------------------- !
#SHEET
#TAB ('Mappoint Class Instantiation')
#DISPLAY ('')
#DISPLAY ('')
#DISPLAY ('Mappoint OCX and Class instantiations:')
#BUTTON  ('Instances'),MULTI(%MPControls,'Control: '& %MPControl &' Instance: '& %MPInst &' Map: '& %MPMap),INLINE
  #PROMPT ('Class instance name: ',@S64),%MPInst,DEFAULT('MPC')
  #PROMPT ('Control associated with class: ',FROM(%Control,(%ControlType='OLE' OR %ControlType='OCX'),%Control)),%MPControl,REQ
  #PROMPT ('Report errors from OCX', CHECK), %MPErrors, AT(100), DEFAULT(1)
  #DISPLAY ('')
  #BOXED ('Default Settings')
  #PROMPT ('Map to load', DROP('North America[1]|Europe[2]')), %MPMap, DEFAULT(2)
  #PROMPT ('Altitude (Miles): ',@N5),%MPAttitude,DEFAULT(100)
  #PROMPT ('3D Map Border: ', CHECK), %MPBorder, DEFAULT(1)
  #PROMPT ('Allow Edge Panning: ', CHECK), %MPEdgePan, DEFAULT(0)
  #ENDBOXED
  #BOXED ('Default Map Address Location')
  #PROMPT ('Use default location: ',CHECK),%USEMPPlace,DEFAULT(0)
  #ENABLE (%USEMPPlace = %TRUE)
  #PROMPT ('State / Place: ',@S65),%MPPlace,DEFAULT('Tampa,FL')
  #PROMPT ('Note: ',@S65),%MPNote,DEFAULT('Start Here')
  #PROMPT ('Symbol: ',@S10),%MPSymbol,DEFAULT('171')
  #PROMPT ('Zoom to this Location : ', CHECK), %MPGoto, DEFAULT(1)
  #ENDENABLE
  #ENDBOXED
  #BOXED ('Activate Toolbars')
  #PROMPT ('Standard toolbar', CHECK), %MPStToolbar, AT(90), DEFAULT(1)
  #PROMPT ('Navigation toolbar', CHECK), %MPNaToolbar, AT(90), DEFAULT(0)
  #PROMPT ('Drawing toolbar', CHECK), %MPDrToolbar, AT(90), DEFAULT(0)
  #PROMPT ('Location and scale toolbar', CHECK), %MPLoToolbar, AT(90), DEFAULT(1)
  #ENDBOXED
#ENDBUTTON
#ENDTAB
#TAB ('About')
#DISPLAY ('Mappoint template and class Version 1.01')
#DISPLAY ('This template and class is freeware.')
#DISPLAY ('For support please visit the clarion newsgroups')
#DISPLAY ('or email either of the authors at:')
#DISPLAY ('')
#DISPLAY ('roel.abspoel@gmail.com')
#DISPLAY ('w_cirino@hotmail.com')
#DISPLAY ('')
#ENDTAB
#ENDSHEET

#! --------------------------------------------------------------------------- !
#AT (%LocalDataAfterClasses),PRIORITY(4000)
#! --------------------------------------------------------------------------- !
! ----- Mappoint class --------------------------------
! This code instantiates the mappoint classes and OCX
! -----------------------------------------------------
#FOR (%MPControls)
%MPInst MappointClass
! -----------------------------------------------------
#ENDFOR
#ENDAT
#! --------------------------------------------------------------------------- !
#AT (%WindowEventHandling,'OpenWindow'),PRIORITY(2000)
#! --------------------------------------------------------------------------- !
#FOR (%MPControls)
! ----- Mappoint class --------------------------------
! This code initializes the mappoint classes
! -----------------------------------------------------
%MPInst.Init(%MPControl,%MPErrors,%MPStToolbar,%MPNaToolbar,%MPDrToolbar,%MPLoToolbar,%MPMap,%MPBorder)
#IF (%USEMPPlace = %TRUE)
%MPInst.AddPinToAddress(%MPSymbol,'%MPPlace','%MPNote','',%MPGoto,TRUE)
#ENDIF
#IF (%MPEdgePan = 1)
%MPInst.AllowEdgePanning(%MPEdgePan)
#ELSE
%MPInst.AllowEdgePanning(0)
#ENDIF
! -----------------------------------------------------
#ENDFOR
#ENDAT
#! --------------------------------------------------------------------------- !
#AT (%WindowEventHandling,'CloseDown'),PRIORITY(2000)
#! --------------------------------------------------------------------------- !
! ----- Mappoint class --------------------------------
! This code sets the saved switch
! -----------------------------------------------------
#FOR (%MPControls)
 %MPInst.Save()
! -----------------------------------------------------
#ENDFOR
#ENDAT
#! --------------------------------------------------------------------------- !
#AT (%WindowEventHandling,'CloseWindow'),PRIORITY(2000)
#! --------------------------------------------------------------------------- !
! ----- Mappoint class --------------------------------
! This code sets the saved switch
! -----------------------------------------------------
#FOR (%MPControls)
 %MPInst.Save()
! -----------------------------------------------------
#ENDFOR
#ENDAT

#! --------------------------------------------------------------------------- !
#CONTROL(AtitudeSpin,'Atitude Spin Control'),Window,REQ(GlobalMappoint(Mappoint))
  #PROMPT ('Class instance name: ',@S64),%MPInst,DEFAULT('MPC')
  CONTROLS
   PROMPT('Altitude:'),USE(?L:Altitude:Prompt)
   SPIN(@n_10),AT(,,50,10),USE(L:Altitude),RANGE(1,20000),STEP(5)
  END
#LocalData
  L:Altitude  Long(15)
#ENDLocalData
#ATSTART
  #DECLARE(%AltitudeControl)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #SET(%AltitudeControl,%Control)
  #ENDFOR
#ENDAT
#AT(%ControlEventHandling,%AltitudeControl,'NewSelection')
   %MPInst.SetAltitude(L:Altitude) !!Willie
#ENDAT
#AT(%ControlEventHandling,%AltitudeControl,'Accepted')
   %MPInst.SetAltitude(L:Altitude) !!Willie
#ENDAT
#! --------------------------------------------------------------------------- !
#CONTROL(StandardToolbar,'Standard Tool Bar Control'),Window,REQ(GlobalMappoint(Mappoint))
  #PROMPT ('Class instance name: ',@S64),%MPInst,DEFAULT('MPC')
  CONTROLS
     BUTTON('...'),USE(?StandardToolbarButton)
   END
#INSERT(%BasicInfo)
#ATSTART
  #DECLARE(%StandardToolBarControl)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #SET(%StandardToolBarControl,%Control)
  #ENDFOR
#ENDAT
#AT(%ControlEventHandling,%StandardToolBarControl,'Accepted')
  if %MPInst.MPControl{'Toolbars.Item("Standard").Visible'} = -1
     %MPInst.MPControl{'Toolbars.Item("Standard").Visible'} = 0
  Elsif %MPInst.MPControl{'Toolbars.Item("Standard").Visible'} = 0
     %MPInst.MPControl{'Toolbars.Item("Standard").Visible'} = -1
  End
#ENDAT

#CONTROL(NavigationToolbar,'Navigation ToolBar Control'),Window
  #PROMPT ('Class instance name: ',@S64),%MPInst,DEFAULT('MPC')
  CONTROLS
     BUTTON('...'),USE(?NavigationToolbarButton)
  END
#ATSTART
  #DECLARE(%NavigationToolBarControl)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #SET(%NavigationToolBarControl,%Control)
  #ENDFOR
#ENDAT
#AT(%ControlEventHandling,%NavigationToolBarControl,'Accepted')
  if %MPInst.MPControl{'Toolbars.Item("Navigation").Visible'} = -1
     %MPInst.MPControl{'Toolbars.Item("Navigation").Visible'} = 0
  Elsif %MPInst.MPControl{'Toolbars.Item("Navigation").Visible'} = 0
     %MPInst.MPControl{'Toolbars.Item("Navigation").Visible'} = -1
  End
#ENDAT
#! --------------------------------------------------------------------------- !
#CONTROL(DrawingToolbar,'Drawing ToolBar Control'),Window,REQ(GlobalMappoint(Mappoint))
  #PROMPT ('Class instance name: ',@S64),%MPInst,DEFAULT('MPC')
  CONTROLS
     BUTTON('...'),USE(?DrawingToolbarButton)
  END
#ATSTART
  #DECLARE(%DrawingToolBarControl)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #SET(%DrawingToolBarControl,%Control)
  #ENDFOR
#ENDAT
#AT(%ControlEventHandling,%DrawingToolBarControl,'Accepted')
  if %MPInst.MPControl{'Toolbars.Item("Drawing").Visible'} = -1
     %MPInst.MPControl{'Toolbars.Item("Drawing").Visible'} = 0
  Elsif %MPInst.MPControl{'Toolbars.Item("Drawing").Visible'} = 0
     %MPInst.MPControl{'Toolbars.Item("Drawing").Visible'} = -1
  End
#ENDAT
#! --------------------------------------------------------------------------- !
#CONTROL(LocationScaleToolbar,'Location Scale ToolBar Control'),Window,REQ(GlobalMappoint(Mappoint))
  #PROMPT ('Class instance name: ',@S64),%MPInst,DEFAULT('MPC')
  CONTROLS
     BUTTON('...'),USE(?LocationScaleToolbarButton)
  END
#ATSTART
  #DECLARE(%LocationScaleToolBarControl)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #SET(%LocationScaleToolBarControl,%Control)
  #ENDFOR
#ENDAT
#AT(%ControlEventHandling,%LocationScaleToolBarControl,'Accepted')
  if %MPInst.MPControl{'Toolbars.Item("Location And Scale").Visible'} = -1
     %MPInst.MPControl{'Toolbars.Item("Location And Scale").Visible'} = 0
  Elsif %MPInst.MPControl{'Toolbars.Item("Location And Scale").Visible'} = 0
     %MPInst.MPControl{'Toolbars.Item("Location And Scale").Visible'} = -1
  End
#ENDAT
#! --------------------------------------------------------------------------- !
#CONTROL(PrintMap,'Print Map Control'),Window,REQ(GlobalMappoint(Mappoint))
#PROMPT ('Class instance name: ',@S64),%MPInst,DEFAULT('MPC')
#PROMPT ('Map Title: ',@S64),%MPTitle,DEFAULT('Mappoint Map Print')
  CONTROLS
     BUTTON('Print'),USE(?PrintMapButton),ICON(ICON:Print)
  END
#ATSTART
  #DECLARE(%PrintMapControl)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #SET(%PrintMapControl,%Control)
  #ENDFOR
#ENDAT
#AT(%ControlEventHandling,%PrintMapControl,'Accepted')
      %MPInst.PrintMap('%MPTitle')
#ENDAT
#! --------------------------------------------------------------------------- !
#CODE(EmbedStandardToolbar,'Standard Tool Bar Embed'),PROCEDURE,MULTI,REQ(GlobalMappoint(Mappoint))
#! --------------------------------------------------------------------------- !
#DISPLAY( 'Insert Code Snip For Standard Toolbar' )
#DISPLAY( ' ' )
  #PROMPT ('Class instance name: ',@S64),%MPInst,DEFAULT('MPC'),REQ
#DISPLAY( ' ' )
  if %MPInst.MPControl{'Toolbars.Item("Standard").Visible'} = -1
     %MPInst.MPControl{'Toolbars.Item("Standard").Visible'} = 0
  Elsif %MPInst.MPControl{'Toolbars.Item("Standard").Visible'} = 0
     %MPInst.MPControl{'Toolbars.Item("Standard").Visible'} = -1
  End
#! --------------------------------------------------------------------------- !
#CODE(EmbedNavigationToolbar,'Navigation Tool Bar Embed'),PROCEDURE,MULTI,REQ(GlobalMappoint(Mappoint))
#! --------------------------------------------------------------------------- !
#DISPLAY( 'Insert Code Snip For Navigation Toolbar' )
#DISPLAY( ' ' )
  #PROMPT ('Class instance name: ',@S64),%MPInst,DEFAULT('MPC'),REQ
#DISPLAY( ' ' )
  if %MPInst.MPControl{'Toolbars.Item("Navigation").Visible'} = -1
     %MPInst.MPControl{'Toolbars.Item("Navigation").Visible'} = 0
  Elsif %MPInst.MPControl{'Toolbars.Item("Navigation").Visible'} = 0
     %MPInst.MPControl{'Toolbars.Item("Navigation").Visible'} = -1
  End
#! --------------------------------------------------------------------------- !
#CODE(EmbedDrawingToolbar,'Drawing Tool Bar Embed'),PROCEDURE,MULTI,REQ(GlobalMappoint(Mappoint))
#! --------------------------------------------------------------------------- !
#DISPLAY( 'Insert Code Snip For Drawing Toolbar' )
#DISPLAY( ' ' )
  #PROMPT ('Class instance name: ',@S64),%MPInst,DEFAULT('MPC'),REQ
#DISPLAY( ' ' )
  if %MPInst.MPControl{'Toolbars.Item("Drawing").Visible'} = -1
     %MPInst.MPControl{'Toolbars.Item("Drawing").Visible'} = 0
  Elsif %MPInst.MPControl{'Toolbars.Item("Drawing").Visible'} = 0
     %MPInst.MPControl{'Toolbars.Item("Drawing").Visible'} = -1
  End
#! --------------------------------------------------------------------------- !
#CODE(EmbedLocationScaleToolbar,'Location/Scale Tool Bar Embed'),PROCEDURE,MULTI,REQ(GlobalMappoint(Mappoint))
#! --------------------------------------------------------------------------- !
#DISPLAY( 'Insert Code Snip For Location / Scale Toolbar' )
#DISPLAY( ' ' )
  #PROMPT ('Class instance name: ',@S64),%MPInst,DEFAULT('MPC'),REQ
#DISPLAY( ' ' )
  if %MPInst.MPControl{'Toolbars.Item("Location And Scale").Visible'} = -1
     %MPInst.MPControl{'Toolbars.Item("Location And Scale").Visible'} = 0
  Elsif %MPInst.MPControl{'Toolbars.Item("Location And Scale").Visible'} = 0
     %MPInst.MPControl{'Toolbars.Item("Location And Scale").Visible'} = -1
  End
#! --------------------------------------------------------------------------- !